{Cache pro obrazky. Pokud nebude dostatek pameti, zacnou se ukladat do XMS}
unit instmem;
interface
uses instxms,vga;
const maxcaches=100;

const pMem=0;   pXMS=1;
type  tcache=object
              pos:byte;
              priority:byte;
              inMem:boolean;
              memadr:pointer;
              xmspos:longint;
              size:longint;
              procedure   init(siz:longint;prior:byte);
              procedure   done;
              procedure   loadpicture(var f:file;prior:byte);
              procedure   getpicture(x,y,x1,y1:word);
              procedure   putpicture(x,y:word);
              procedure   optimize;
            end;
       pcache=^tcache;
var XMScache:XFileType;
var pic:array[1..maxcaches] of tcache;
    win:array[1..20] of tcache;
    picc,winused:word;

implementation
uses install5;
procedure tcache.init(siz:longint;prior:byte);
begin
 picc:=picc+1;
 priority:=prior;
 size:=siz;
 if (prior=0) {or (memavail<siz)} then            {do XMS}
 begin
  XMScache.pozition:=XMScache.size;                    {-Zvetsim velikost}
  XMScache.size:=XMScache.size+siz;                    { XMS buferu}
  reallocXMS(XMScache.handle,XMScache.size);
  inMem:=false;
  XMSpos:=XMScache.pozition;
  memadr:=nil;
 end else
 begin                                          {do zakladni pameti}
  getmem(memadr,siz);
  inMem:=true;
 end;
end;

procedure  tcache.done;
begin
 if inMem then
 begin
  freemem(memadr,size);
 end else
 begin
  if xmspos+size<>XMScache.size then                    {Nejsme na konci XMS}
  begin
{doplnit}
  end;
  xmshandleerr:=true;
  reallocXMS(XMScache.handle,XMScache.size-size);
  xmshandleerr:=false;
 end;

end;

procedure tcache.loadpicture(var f:file;prior:byte);
var len,wtd:longint;
    x,y,wt:word;
    buffer:array[1..1024]of byte;
begin
{$I-}blockread(f,x,sizeof(x));
 blockread(f,y,sizeof(y));
 len:=x*y+4;
 seek(f,filepos(f)-4);{$I+}
 if ioresult<>0 then
    begin error('Chyba pi ten souboru s obrzkem',0,0,erOK);exit;end;
 init(len,prior);
 if inMem then
 begin
  {$I-}blockread(f,memadr^,len);{$I+}
   if ioresult<>0 then
    begin error('Chyba pi ten souboru s obrzkem',0,0,erOK);exit;end;
 end
 else begin                             {do XMS}
  wtd:=0;
  while wtd<len do
  begin
 {$I-}blockread(f,buffer,sizeof(buffer),wt);{$I+}
   if ioresult<>0 then
    begin error('Chyba pi ten souboru s obrzkem',0,0,erOK);exit;end;

   if wtd+wt>len then wt:=len-wtd;
   wtd:=wtd+wt;
   XWrite(XMScache,@buffer,wt);
  end;
 end;
end;

procedure tcache.putpicture(x,y:word);
begin
 if inMem then vga.putpicture(x,y,memadr)
          else xputpicture(x,y,XMScache,xmspos);
end;

procedure tcache.getpicture(x,y,x1,y1:word);
begin
 if inMem then mgetpicture(x,y,x1,y1,memadr)
          else xgetpicture(x,y,x1,y1,XMScache,xmspos);
end;
procedure tcache.optimize;
begin
end;
end.