unit instxms;
interface
type       XFileType=record
                  handle:word;
                  pozition,
                  size:longint;
                end;
var XMSaddr:longint;
    XMSerror:byte;
    xmshandleerr:boolean;
function  testXMS:boolean;
function  XMSver:word;
function  XMSmaxblock:word;
function  XMSfree:word;
procedure reallocXMS(handle,length:word);
function  allocXMS(size:word):word;
procedure deallocXMS(handle:word);
procedure moveXMS(SHandle,SSeg,SOfs,DHandle,DSeg,DOfs:word;Length:longint);
procedure basetoXMS(SSeg,SOfs,DHandle:word;Length:longint);
procedure XMStoBase(SHandle,DSeg,DOfs:word;Length:longint);
procedure XMStoXMS(SHandle,DHandle:word;Length:longint);

procedure XAssign(var f:XFileType;size:word);
procedure XRead(var f:XFileType;dest:pointer;size:longint);
procedure XWrite(var f:XFileType;dest:pointer;size:longint);
procedure XSeek(var f:XFileType;poz:longint);
function  XPoz(var f:XFileType):longint;
function  XSize(var f:XFileType):longint;
procedure XClose(var f:XFileType);

procedure xputpicture(vx,vy:word;xms:xfiletype;start:longint);
procedure mgetpicture(x,y,x1,y1:integer;p:pointer);
procedure xgetpicture(x,y,x1,y1:word;xms:xfiletype;start:longint);



implementation
uses dos,vga,install5;
{$F+}
procedure longcall(addr: longint; var regs: registers); external;
{$L d:\bp\obj\INFOPLUS}
{$F-}
function testXMS:boolean;
var r:registers;
begin
 r.ah:=$43;
 r.al:=$00;
 intr($2F,r);
 if r.al=$80 then testXMS:=true else testXMS:=false;
 if r.al<>$80 then exit else
 begin
  r.AX:=$4310;
  intr($2F,r);
  XMSaddr:=longint(r.es) shl 16 + r.bx;
 end;
 XMSerror:=0;
end;
function XMSver:word;
var r:registers;
begin
 r.AX:=$4300;
 intr($2F,r);
 if r.al<>$80 then exit else
 begin
  r.AX:=$4310;
  intr($2F,r);
  XMSaddr:=longint(r.es) shl 16 + r.bx;
  r.ax:=0;
  longcall(XMSaddr, r);
  XMSver:=r.ax;
 end;
end;

function XMSmaxblock:word;
var r:registers;
begin
 r.ah:=08;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 XMSmaxblock:=r.ax;
end;
function XMSfree:word;
var r:registers;
begin
 r.ah:=08;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 XMSfree:=r.dx;
end;
procedure reallocXMS(handle,length:word);
var r:registers;
begin
 r.ah:=$0F;
 r.dx:=handle;
 r.bx:=length;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else begin XMSerror:=r.bl;
    if not xmshandleerr then error('Chyba pi realokaci pamti XMS',0,XMSerror,erOK);end;
end;
function allocXMS(size:word):word;
var r:registers;
begin
 r.ah:=09;
 r.dx:=size;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else begin XMSerror:=r.bl;
 if not xmshandleerr then error('Chyba pi alokaci pamti XMS',0,XMSerror,erOK);end;
 allocXMS:=r.dx;
end;
procedure deallocXMS(handle:word);
var r:registers;
begin
 r.ah:=$0A;
 r.dx:=handle;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else begin XMSerror:=r.bl;
 if not xmshandleerr then error('Chyba pi dealokaci pamti XMS',0,XMSerror,erOK);end;
end;
procedure moveXMS(SHandle,SSeg,SOfs,DHandle,DSeg,DOfs:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=Shandle;Sse:=SSeg;Sof:=SOfs;Dha:=Dhandle;Dse:=DSeg;Dof:=Dofs;
 end;

 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else begin XMSerror:=r.bl;
 if not xmshandleerr then error('Chyba pi pesunu pamti XMS',0,XMSerror,erOK);end;
end;
procedure basetoXMS(SSeg,SOfs,DHandle:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=0;Sse:=SSeg;Sof:=SOfs;Dha:=Dhandle;Dse:=0;Dof:=0;
 end;
 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else begin XMSerror:=r.bl;
 if not xmshandleerr then error('Chyba pi pesunu bloku zkladn pamti do XMS.',0,XMSerror,erOK);end;
end;
procedure XMStoXMS(SHandle,DHandle:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=Shandle;Sse:=0;Sof:=0;Dha:=DHandle;Dse:=0;Dof:=0;
 end;
 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else begin XMSerror:=r.bl;
 if not xmshandleerr then error('Chyba pi pesunu bloku pamti XMS do jinho bloku XMS.',0,XMSerror,erOK);end;XMSerror:=r.bl;
end;
procedure XMStoBase(SHandle,DSeg,DOfs:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=Shandle;Sse:=0;Sof:=0;Dha:=0;Dse:=Dseg;Dof:=Dofs;
 end;
 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else begin  XMSerror:=r.bl;
 if not xmshandleerr then error('Chyba pi pesunu bloku pamti XMS do zkladn pamti.',0,XMSerror,erOK);end;
end;

procedure XAssign(var f:XFileType;size:word);
var lastxmse:boolean;
begin
 lastxmse:=xmshandleerr;
 xmshandleerr:=true;
 f.handle:=allocXMS(size);
 f.size:=size;
 f.pozition:=0;
 xmshandleerr:=lastxmse;
 if not xmshandleerr then
    if XMSerror<>0 then error('Chyba pi vytven XMS vyrovnvacho souboru.',0,XMSerror,erOK);
end;
procedure XRead(var f:XFileType;dest:pointer;size:longint);
var lastxmse:boolean;
begin
 lastxmse:=xmshandleerr;
 xmshandleerr:=true;
 if f.handle=0 then
 begin
  XMSerror:=$A2;
  if not lastxmse then
     if XMSerror<>0 then error('Chyba pi ten z XMS vyrovnvacho souboru.',0,XMSerror,erOK);
  xmshandleerr:=false;
  exit;
 end;
 moveXMS(f.handle,f.pozition div 65535,f.pozition mod 65535,0,seg(dest^),ofs(dest^),size);
 if XMSerror<>0 then error('Chyba pi ten z XMS vyrovnvacho souboru.',0,XMSerror,erOK);
 f.pozition:=f.pozition+size;
 xmshandleerr:=lastxmse;
end;
procedure XWrite(var f:XFileType;dest:pointer;size:longint);
var lastxmse:boolean;
begin
 lastxmse:=xmshandleerr;
 xmshandleerr:=true;
 if f.handle=0 then
 begin
  XMSerror:=$A2;
  if not lastxmse then
     if XMSerror<>0 then error('Chyba pi zpisu z XMS vyrovnvacho souboru.',0,XMSerror,erOK);
  xmshandleerr:=false;
  exit;
 end;
 moveXMS(0,seg(dest^),ofs(dest^),f.handle,f.pozition div 65535,f.pozition mod 65535,size);
 f.pozition:=f.pozition+size;
 xmshandleerr:=lastxmse;
end;
procedure XSeek(var f:XFileType;poz:longint);
begin
 f.pozition:=poz;
end;
function  XSize(var f:XFileType):longint;
begin
 XSize:=f.size;
end;
function  XPoz(var f:XFileType):longint;
begin
 XPoz:=f.pozition;
end;
procedure XClose(var f:XFileType);
var lastxmse:boolean;
begin
 lastxmse:=xmshandleerr;
 xmshandleerr:=true;
 deallocXMS(f.handle);
 xmshandleerr:=lastxmse;
 if not xmshandleerr then
    if XMSerror<>0 then error('Chyba pi uzavrn XMS vyrovnvacho souboru.',0,XMSerror,erOK);
end;
procedure xputpicture(vx,vy:word;xms:xfiletype;start:longint);
var i,l,x,y:word;buffer:array[1..2048] of byte;
begin
 xmshandleerr:=true;
 xseek(xms,start);
 xread(xms,@x,2);xread(xms,@y,2);
 if XMSerror<>0 then
 begin
  error('Chyba pi zobrazovn obrzku z XMS.',0,XMSerror,erOK);
  xmshandleerr:=false;
  exit;
 end;

 if (x>640) or (x<0) or (y>640) or (y<0) then
 begin
  error('Chyba pi zobrazovn obrzku. Obrzek m neplatn rozmry.',0,XMSerror,erOK);
  xmshandleerr:=false;
  exit;
 end;

 for i:=0 to y-1 do
 begin
   XRead(xms, @Buffer, x);
   if XMSerror<>0 then
   begin
    error('Chyba pi zobrazovn obrzku z XMS.',0,XMSerror,erOK);
    xmshandleerr:=false;
    exit;
   end;
   for l:=0 to x-2 do begin putpixel(vx+l,vy+i,buffer[l+1]);end;
 end;
 xmshandleerr:=false;
end;
procedure mgetpicture(x,y,x1,y1:integer;p:pointer);
var i,l:integer;se,off:word;
begin
 se:=seg(p^);off:=ofs(p^);
 memw[se:off]:=x1-x;
 memw[se:off+2]:=y1-y;
 for l:=0 to y1-y-1 do
 for i:=0 to x1-x-1 do
 begin
  mem[se:off+(l*(x1-x))+4+i]:=getpixel(x+i,y+l);
 end;
end;

procedure xgetpicture(x,y,x1,y1:word;xms:xfiletype;start:longint);
var wx,wy,i,l:word;buffer:array[1..2048] of byte;q:longint;
begin
 xmshandleerr:=true;
 wx:=x1-x;wy:=y1-y;
 xseek(xms,start);
 xwrite(xms,@wx,2);xwrite(xms,@wy,2);q:=0;
 if XMSerror<>0 then
 begin
  error('Chyba pi ukldn sti obrazovky do vyrovnvacho XMS souboru.',0,XMSerror,erOK);
  xmshandleerr:=false;
  exit;
 end;
 for i:=y to y1 do
 begin
   for l:=1 to wx do begin buffer[l]:=getpixel(x+l-1,i);end;
   XWrite(xms, @Buffer, wx);
   if XMSerror<>0 then
   begin
    error('Chyba pi ukldn sti obrazovky do vyrovnvacho XMS souboru.',0,XMSerror,erOK);
    xmshandleerr:=false;
    exit;
   end;
 end;
 xmshandleerr:=false;
end;
end.