unit man_tool;
interface

var ddd1:array[0..255] of char;
var savedscr:array[1..80*24*2] of char;

procedure savetxtscr;
procedure restoretxtscr;
function getextension(s:string):string;
procedure beep(f,d:word);
function inttostr(i:longint):string;
function updir(s:string):string;
function maxlength(s:string;l:integer):string;
function maxlength1(s:string;l:integer):string;
function LeadingZero(w : Word) : String;
function uppercase(s:string):string;
procedure membar;
function FromAsciz(a:pchar):string;
function ToAsciz(a:string):pchar;
function getformatstr(ext:string):string;
function Hex(B :byte) :string;
function HexW(W :word) :string;
function HexL(L :longint) :string;

implementation
uses crt,vga;


procedure savetxtscr;
begin
 move(ptr(segb800,0)^,savedscr,sizeof(savedscr));
end;
procedure restoretxtscr;
begin
 move(savedscr,ptr(segb800,0)^,sizeof(savedscr));
end;
function getextension(s:string):string;
begin
 delete(s,1,length(s)-4);
 if pos('.',s)>0 then delete(s,1,pos('.',s)) else s:='';
 getextension:=s;
end;
procedure beep(f,d:word);
begin
 sound(f);delay(d);nosound;
end;
function inttostr(i:longint):string;
var s:string;
begin
 str(i,s);
 inttostr:=s;
end;
function updir(s:string):string;
var i:integer;s1:string;
begin

 s1:='';if s[length(s)]='\' then s[0]:=chr(ord(s[0])-1);
 for i:=length(s) downto 1 do
 begin
  if s[i]<>'\' then s1:=s[i]+s1 else break;
 end;
 updir:=s1;
end;
function maxlength(s:string;l:integer):string;
begin
 if length(s)>l then
 begin
{  s[0]:=chr(l-3);
  s:=s+'...';}
  delete(s,1,length(s)-l);
  delete(s,1,3);
  s:='...'+s;
 end;
 maxlength:=s;
end;
function maxlength1(s:string;l:integer):string;
begin
 if length(s)>l then
 begin
  s[0]:=chr(l-3);
  if l>3 then
    s:=s+'...'
  else s:='';
 end;
 maxlength1:=s;
end;
function LeadingZero(w : Word) : String;
var
  s : String;
begin
  Str(w:0,s);
  if Length(s) = 1 then
    s := '0' + s;
  LeadingZero := s;
end;
function uppercase(s:string):string;
var i:integer;
begin
 for i:=1 to length(s) do s[i]:=upcase(s[i]);
 uppercase:=s;
end;
procedure membar;
begin
  hline(memavail div 1024,475,640-memavail div 1024,1);
  hline(memavail div 1024,476,640-memavail div 1024,1);
  hline(memavail div 1024,477,640-memavail div 1024,1);

  hline(0,475,memavail div 1024,4);
  hline(0,476,memavail div 1024,4);
  hline(0,477,memavail div 1024,4);
end;
function FromAsciz(a:pchar):string;
var s:string;i:integer;
begin
 i:=0;
 s:='';while a[i]<>#0 do begin s:=s+a[i];i:=i+1;end;
 fromasciz:=s;
end;
function ToAsciz(a:string):pchar;
var s:pchar;i:integer;
begin
 i:=1;
 for i:=1 to length(a) do ddd1[i-1]:=a[i];
 ddd1[i]:=#0;
 toasciz:=addr(ddd1);
end;
function getformatstr(ext:string):string;
var s:string;
begin
  ext:=uppercase(ext);
  if (ext='EXE') or (ext='COM') then s:='Spustitelny soubor' else
  if (ext='BAT')                then s:='Davkovy soubor' else
  if (ext='INI') or (ext='CFG') then s:='Kongfiguracni soubor' else
  if (ext='ARJ') or (ext='ZIP')
                 or (ext='RAR') then s:='Zkomprimovana data' else
  if (ext='TXT') or (ext='DOC')
                 or (ext='HTM') then s:='Textovy soubor' else
  if (ext='VAW') or (ext='VOC')
  or (ext='MID') or (ext='MOD')
  or (ext='MP2') or (ext='MP3') then s:='Zvukovy zaznam' else
  if (ext='BMP') or (ext='PCX')
  or (ext='JPG') or (ext='GIF')
  or (ext='PNG') or (ext='TGA')
  or (ext='TIF') or (ext='CUT') then s:='Obrazek' else
  if (ext='ICO')                then s:='Ikona' else
  if (ext='BAK')                then s:='Zalozni kopie' else
  if (ext='TMP') or (ext='$$$') then s:='Docasny soubor' else
  if (ext='PAS') or (ext='CPP')
  or (ext='BAS') or (ext='C--')
  or (ext='H--') or (ext='ASM') then s:='Zdrojovy kod' else
  if ext='' then s:='Bez koncovky' else
  s:='Neznamy typ souboru';


  getformatstr:=s;
end;
function Hex(B :byte) :string;
 CONST  strdex :array [0..$F] of char = '0123456789ABCDEF';
 BEGIN  Hex := concat(strdex[B shr 4], strdex[B and $F]); END;

function HexW(W :word) :string;
 VAR    byt :array [0..1] of byte absolute W;
 BEGIN  HexW := Hex(byt[1])+Hex(byt[0]); END;

function HexL(L :longint) :string;
 TYPE   Cast = RECORD
                Lo :word;
                Hi :word;
         END;
 BEGIN  HexL := HexW(Cast(L).Hi)+' '+HexW(Cast(L).Lo); END;

end.