unit instobjs;
interface
uses vga;
var frame1, frame2, bar1, black1:byte;
type string2=string[2];

const wheresave:integer=0;
      startwindowwidth:integer=102;
const btNothing=0;
      btYes       = $0001;
      btNo        = $0002;
      btContinue  = $0004;
      btAbort     = $0008;
      btAll       = $0010;
      btNever     = $0020;
      btOk        = $0040;
      btCustom    = $0080;
      btIgnore    = $0100;
      btRetro     = $0200;
      btEnd       = $0400;

      alLeft=1;
      alRight=2;
      alCenter=3;
type toncreate=procedure;
     tonclose =procedure;
     tontimer =procedure;
var   oncreate:toncreate;
      onclose:tonclose;
      ontimer:tontimer;
type tbutton=object
      x,y,x1,y1:word;
      active,down:boolean;
      caption:string;
      event:word;
      picture:{pointer}word;
      procedure draw;
      procedure oznac;
      procedure odznac;
      function  kolize(xx,yy:word):boolean;
      procedure new(px,py,px1,py1:word;pcaption:string);
     end;
type toptionbar=object
      x,y,x1,y1:word;
      active,down:boolean;
      caption:string;
      procedure draw;
      procedure zapni(z:boolean);
      procedure oznac;
      procedure odznac;
      function  kolize(xx,yy:word):boolean;
      procedure new(px,py:word;pcaption:string;d:boolean);
     end;
type tnotebook=object
      x,y,x1,y1:word;
      active:boolean;
      down:integer;
      captions:array[1..7] of string;
      desks,desksize:integer;
      procedure draw;
      procedure zapni(z:integer);
      procedure oznac;
      procedure odznac;
      function  kolize(xx,yy:word):integer;
      procedure new(px,py,px1,py1:word);
     end;
type tedit=object
      x,y,x1,y1:word;
      zobrc,zobrmax,maxc,akc,ozns:word;
      active,down:boolean;
      caption:string;
      event:word;
      procedure draw;
      procedure new(px,py,px1:word;pcaption:string);
      function  checkevent(mx,my:word;t1:boolean;ch:string2):boolean;
     end;
type twindow=object
      x,y,x1,y1:word;
      saved:{pointer}word;
      savedin,savedcolor:byte;
      b:array[1..10] of tbutton;
      btns:array[1..10] of word;
      akb,bcount:integer;
      caption:string;
      procedure settimer(t:tontimer);
      procedure draw;
      procedure new(px,py,px1,py1:word;pcaption:string);
      procedure run(xx:word;align:word);
      function  checkevent:word;
      function  checkpevent(mx,my:word;t1:boolean;ch:string2):word;
      procedure destroy;
     end;
var schranka:string;
implementation
uses crt, instmem, man_key;
procedure tnotebook.draw;
var i,xxx:integer;
begin
 hidemouse;
 hline(x,y-1,x1-x,7);
 hline(x,y1,x1-x,15);
 for i:=1 to desks do
 begin
  xxx:=x+((i-1)*desksize)+5;

  bar(xxx,y,xxx+desksize,y1-1,7);

  hline(xxx,y,desksize,15);
  vline(xxx,y,y1-y-1,15);
  vline(xxx+desksize-1,y,y1-y-1,0);

  outtext(xxx+2,y+2,captions[i],0,@normal);



 end;

 xxx:=x+((down-1)*desksize)+5;

 hline(xxx,y1,desksize-1,7);

  hline(xxx,y,desksize,7);
  vline(xxx,y,y1-y-1,7);
  vline(xxx+desksize-1,y,y1-y-1,8);

  hline(xxx,y-1,desksize,15);
  vline(xxx-1,y,y1-y,15);
  vline(xxx+desksize,y,y1-y,0);


 if active then rectangle(xxx+1,y+1,xxx+length(captions[down])*8+2,y+18,1);

 showmouse;
end;
{procedure tnotebook.new(px,py:word;pcaption:string;d:boolean);
begin
 x:=px;y:=py;
 x1:=x+16+(length(pcaption)*8);
 y1:=y+16;
 caption:=pcaption;
 down:=d;
 active:=false;
 draw;
end;}

procedure tnotebook.oznac;
var xxx:integer;
begin
 hidemouse;
 xxx:=x+((down-1)*desksize)+5;
 rectangle(xxx+1,y+1,xxx+length(captions[down])*8+2,y+18,1);
 showmouse;
 active:=true;
end;

procedure tnotebook.odznac;
var xxx:integer;
begin
 hidemouse;
 xxx:=x+((down-1)*desksize)+5;
 rectangle(xxx+1,y+1,xxx+length(captions[down])*8+2,y+18,7);
 active:=false;
end;

procedure tnotebook.zapni(z:integer);
begin
 down:=z;
 draw;
end;

function  tnotebook.kolize(xx,yy:word):integer;
var k:integer;
begin
 if not inarea(xx,yy,x,y,x1,y1) then begin kolize:=0;exit;end;
 k:=((xx-x) div desksize)+1;
 if k>desks then begin kolize:=0;exit;end;
 kolize:=k;
end;

procedure tnotebook.new(px,py,px1,py1:word);
var i:integer;
begin
 x:=px;y:=py;
 x1:=px1;y1:=py1;
 down:=1;
 active:=false;desksize:=0;
 for i:=1 to desks do if length(captions[i])>desksize then desksize:=length(captions[i]);
 desksize:=desksize*8+10;
 draw;
end;




procedure twindow.settimer(t:tontimer);
begin
 ontimer:=t;
end;
procedure toptionbar.draw;
var stred:word;
begin
 hidemouse;
 if active then rectangle(x-1,y-1,x1+1,y1+1,1)
           else rectangle(x-1,y-1,x1+1,y1+1,7);

 bar(x+1,y+1,x+15,y+15,bar1);
 if down then begin frame(x,y,x+16,y+16,frame2,frame1,frame1,frame2);
               line(x+2,y+9,x+9,y+15,4);line(x+9,y+15,x+15,y+2,4);
              end
         else frame(x,y,x+16,y+16,frame1,frame2,frame2,frame1);
 outtext(x+16,y+2,caption,0,@normal);
 showmouse;
end;
procedure toptionbar.new(px,py:word;pcaption:string;d:boolean);
begin
 x:=px;y:=py;
 x1:=x+16+(length(pcaption)*8);
 y1:=y+16;
 caption:=pcaption;
 down:=d;
 active:=false;
 draw;
end;

procedure toptionbar.oznac;
begin
 hidemouse;rectangle(x-1,y-1,x1+1,y1+1,0);showmouse;
 active:=true;
end;

procedure toptionbar.odznac;
begin
 hidemouse;rectangle(x-1,y-1,x1+1,y1+1,7);showmouse;
 active:=false;
end;

procedure toptionbar.zapni(z:boolean);
begin
 down:=z;
 draw;
end;


function  toptionbar.kolize(xx,yy:word):boolean;
begin
 if inarea(xx,yy,x,y,x1,y1) then kolize:=true else kolize:=false;
end;

procedure tbutton.draw;
var stred:word;
begin
 hidemouse;
 if active then rectangle(x-1,y-1,x1+1,y1+1,0)
           else rectangle(x-1,y-1,x1+1,y1+1,7);
 if down then frame(x,y,x1,y1,frame2,frame1,frame1,frame2)
         else frame(x,y,x1,y1,frame1,frame2,frame2,frame1);
 bar(x+1,y+1,x1-1,y1-1,bar1);
 if picture=0 then
 begin
  stred:=(x1-x-length(caption)*8) div 2;
  outtext(x+stred,y+2,caption,0,@normal);
 end else
 begin
  ignorecolor:=16;
  pic[picture].putpicture(x+1,y+1);
  outtext(x+19,y+2,caption,0,@normal);
 end;

 showmouse;
end;
procedure tbutton.new(px,py,px1,py1:word;pcaption:string);
begin
 x:=px;y:=py;
 x1:=px1;y1:=py1;
 caption:=pcaption;
 down:=false;
 active:=false;
 draw;
end;

procedure tbutton.oznac;
begin
 rectangle(x-1,y-1,x1+1,y1+1,0);
 active:=true;
end;

procedure tbutton.odznac;
begin
 rectangle(x-1,y-1,x1+1,y1+1,7);
 active:=false;
end;

function  tbutton.kolize(xx,yy:word):boolean;
begin
 if inarea(xx,yy,x,y,x1,y1) then kolize:=true else kolize:=false;
end;

procedure twindow.draw;
begin
 hidemouse;
 frame(x,y,x1,y1,frame1,frame2,frame2,frame1);
 twocolorhbar(x+1,y+1,x1-1,y+16,9,1);
 bar(x+1,y+17,x1-1,y1-1,bar1);
 outtext(x+2,y+2,caption,15,@fun);
 showmouse;
end;

procedure twindow.destroy;
begin
 if savedin=0 then
 begin
  hidemouse;ignorecolor:=16;
  win[saved].putpicture(x,y);showmouse;
  win[saved].done;
  winused:=winused-1;
 end;
 if savedin=1 then
 begin
  hidemouse;
  bar(x,y,x1,y1,savedcolor);
  showmouse;
 end;
end;

procedure  twindow.run(xx:word;align:word);
var btcount:word;i,l:integer;
    t1,t2,t3:boolean;mx,my:word;
procedure createbutton(x,y,xxx,idx:word);
begin
 b[idx].x:=x;b[idx].y:=y;b[idx].x1:=x+startwindowwidth;b[idx].y1:=y+18;
 b[idx].event:=xxx;b[idx].down:=false;
 case xxx of
      btYes:b[idx].caption:='Ano';
      btOk:b[idx].caption:='OK';
      btNo:b[idx].caption:='Ne';
      btContinue:b[idx].caption:='Pokraovat';
      btAbort:b[idx].caption:='Zruit';
      btAll:b[idx].caption:='Vechny';
      btNever:b[idx].caption:='dn';

      btIgnore:b[idx].caption:='Ignorovat';
      btRetro:b[idx].caption:='Opakovat';
      btEnd:b[idx].caption:='Konec';

 end;
 b[idx].draw;
end;
var sg,og:word;
begin
 nic;
 btcount:=0;
 if (xx and btYes)=btYes then begin btcount:=btcount+1;btns[btcount]:=btYes;end;
 if (xx and btOk)=btOk then begin btcount:=btcount+1;btns[btcount]:=btOk;end;
 if (xx and btNo)=btNo then begin btcount:=btcount+1;btns[btcount]:=btNo;end;
 if (xx and btAll)=btAll then begin btcount:=btcount+1;btns[btcount]:=btAll;end;
 if (xx and btNever)=btNever then begin btcount:=btcount+1;btns[btcount]:=btNever;end;
 if (xx and btContinue)=btContinue then begin btcount:=btcount+1;btns[btcount]:=btContinue;end;
 if (xx and btAbort)=btAbort then begin btcount:=btcount+1;btns[btcount]:=btAbort;end;
 if (xx and btRetro)=btRetro then begin btcount:=btcount+1;btns[btcount]:=btRetro;end;
 if (xx and btIgnore)=btIgnore then begin btcount:=btcount+1;btns[btcount]:=btIgnore;end;
 if (xx and btEnd)=btEnd then begin btcount:=btcount+1;btns[btcount]:=btEnd;end;
 if (xx and btCustom)=btCustom then begin btcount:=btcount+1;end;

 for i:=1 to btcount do
 case align of
  alLeft:createbutton(x+(i-1)*(startwindowwidth+2),y1-21,btns[i],i);
  alRight:createbutton(x1-(btcount-i+1)*(startwindowwidth+2),y1-21,btns[i],i);
  alCenter:createbutton(x+(i-1)*(startwindowwidth+2)+((x1-x)-(btcount*(startwindowwidth+2))) div 2,y1-21,btns[i],i);
 end;
 b[1].oznac;akb:=1;
 bcount:=btcount;
end;

function twindow.checkevent:word;
var btcount:word;i,l:integer;
    t1,t2,t3:boolean;mx,my:word;
    ch:char;
begin
  btcount:=bcount;
  mousestatus(mx,my,t1,t2,t3);
  checkevent:=btNothing;
  if t1 then for i:=1 to btcount do if b[i].kolize(mx,my) then
  begin
   for l:=1 to btcount do b[l].odznac;
   b[i].down:=true;
   b[i].oznac;
   b[i].draw;
   repeat
    mousestatus(mx,my,t1,t2,t3);
   until not t1;
   if b[i].kolize(mx,my) then
   begin
    checkevent:=b[i].event;
   end;
   b[i].down:=false;
   akb:=i;
   for l:=1 to btcount do b[l].draw;
  end;
  ch:=#255;
  if keypressed then ch:=readkey;
  if ch=k_Tab then    if akb>1       then begin akb:=akb-1;b[akb+1].odznac;b[akb].oznac;end
                                     else begin b[1].odznac;akb:=btcount;b[akb].oznac;end;
  if ch=#0 then
  begin
   ch:=readkey;
   if ch=k_Right then if akb<btcount then begin akb:=akb+1;b[akb-1].odznac;b[akb].oznac;end
                                     else begin akb:=1;b[akb].oznac;b[btcount].odznac;end;
   if ch=k_Left then  if akb>1       then begin akb:=akb-1;b[akb+1].odznac;b[akb].oznac;end
                                     else begin akb:=btcount;b[1].odznac;b[akb].oznac;end;
  end;
  if ch=k_Esc then begin checkevent:=btAbort;end;
  if ch=k_Enter then begin checkevent:=b[akb].event;end;
end;
function twindow.checkpevent(mx,my:word;t1:boolean;ch:string2):word;
var btcount:word;i,l:integer;
    t2,t3:boolean;
begin
  btcount:=bcount;
  checkpevent:=btNothing;
  if t1 then for i:=1 to btcount do if b[i].kolize(mx,my) then
  begin
   for l:=1 to btcount do b[l].odznac;
   b[i].down:=true;
   b[i].oznac;
   b[i].draw;
   repeat
    mousestatus(mx,my,t1,t2,t3);
   until not t1;
   if b[i].kolize(mx,my) then
   begin
    checkpevent:=b[i].event;
   end;
   b[i].down:=false;
   akb:=i;
   for l:=1 to btcount do b[l].draw;
  end;
  if ch[1]=k_Tab then    if akb>1       then begin akb:=akb-1;b[akb+1].odznac;b[akb].oznac;end
                                     else begin b[1].odznac;akb:=btcount;b[akb].oznac;end;
  if ch[1]=#0 then
  begin
   if ch[2]=k_Right then if akb<btcount then begin akb:=akb+1;b[akb-1].odznac;b[akb].oznac;end
                                     else begin akb:=1;b[akb].oznac;b[btcount].odznac;end;
   if ch[2]=k_Left then  if akb>1       then begin akb:=akb-1;b[akb+1].odznac;b[akb].oznac;end
                                     else begin akb:=btcount;b[1].odznac;b[akb].oznac;end;
  end;
  if ch[1]=k_Esc then begin checkpevent:=btAbort;end;
  if ch[1]=k_Enter then begin checkpevent:=b[akb].event;end;
end;
procedure twindow.new(px,py,px1,py1:word;pcaption:string);
begin
 oncreate:=nic;
 onclose:=nic;
 ontimer:=nic;
 x:=px;y:=py;
 x1:=px1;y1:=py1;
 caption:=pcaption;

 if savedin=0 then
 begin
  winused:=winused+1;
  saved:=winused;

  win[saved].init(4+(x1-x)*(y1-y),wheresave);
  hidemouse;
  win[saved].getpicture(x,y,x1+1,y1);
  showmouse;
 end;
 draw;
end;


procedure tedit.draw;
var i,l,m:integer;
begin
 hidemouse;
 frame(x,y,x1,y1,frame2,frame1,frame1,frame2);
 bar(x+1,y+1,x1-1,y1-1,15);
 i:=akc-zobrc;
 l:=ozns-zobrc-1;
 if l<0 then l:=0;
 if l>zobrmax-1 then l:=zobrmax-1;
 if akc<>zobrc then
   if l>i then bar(x+i*8,y+1,x+l*8,y+15,1)
          else bar(x+l*8,y+1,x+i*8,y+15,1);
 m:=zobrmax;
 if m+zobrc-2>length(caption) then m:=length(caption)-zobrc;
 outtext(x,y+1,
        copy(caption,zobrc,m+1),0,@normal);
 vline(x+(akc-zobrc)*8,y+1,14,4);
 showmouse;
end;
procedure tedit.new(px,py,px1:word;pcaption:string);
begin
 x:=px;y:=py;
 x1:=px1;y1:=y+16;
 caption:=pcaption;
 akc:=length(caption)+1;
 ozns:=akc+1;
 maxc:=255;
 zobrc:=1;
 zobrmax:=((x1-x) div 8)-1;
 draw;
end;

function  tedit.checkevent(mx,my:word;t1:boolean;ch:string2):boolean;
begin
 if (ch[1]<>#0) and (ord(ch[1])>30) and (length(caption)<maxc) then
 begin
  akc:=akc-1;
  caption:=copy(caption,1,akc)+ch[1]+copy(caption,akc+1,length(caption)-akc);
  akc:=akc+2;
  if akc+1>zobrc+zobrmax then zobrc:=zobrc+1;
  hidemouse;bar(x+1,y+1,x1-1,y1-1,15);showmouse;
  ozns:=akc+1;
  draw;
 end;
 if (ch[1]=k_backspace) and (akc>0) then
 begin
  delete(caption,akc-1,1);
  akc:=akc-1;
  if akc<zobrc then zobrc:=akc;
  hidemouse;bar(x+1,y+1,x1-1,y1-1,15);showmouse;
  ozns:=akc+1;
  draw;
 end;
 if length(ch)=2 then
 case ch[2] of
  k_Left:if akc>1 then
     begin
      akc:=akc-1;hidemouse;bar(x+1,y+1,x1-1,y1-1,15);showmouse;
      if akc<zobrc then zobrc:=akc;
      if not SHIFTPRESSED then ozns:=akc+1;
      draw;
     end;
  k_Right:if akc<length(caption)+1 then
     begin
      akc:=akc+1;hidemouse;bar(x+1,y+1,x1-1,y1-1,15);showmouse;
      if akc+1>zobrc+zobrmax then zobrc:=zobrc+1;
      if not SHIFTPRESSED then ozns:=akc+1;
      draw;
     end;
  k_End:begin akc:=length(caption)+1;
         hidemouse;bar(x+1,y+1,x1-1,y1-1,15);showmouse;
         if not SHIFTPRESSED then ozns:=akc+1;
         if akc>zobrc+zobrmax then zobrc:=akc-zobrc-zobrmax+2 else zobrc:=1;
         ozns:=akc+1;{*}
         draw;end;
  k_Home:begin akc:=1;
          if not SHIFTPRESSED then ozns:=akc+1;
          hidemouse;bar(x+1,y+1,x1-1,y1-1,15);showmouse;zobrc:=1;
          ozns:=akc+1;{*}
          draw;
         end;
  k_del: if akc<length(caption) then
  begin
   delete(caption,akc,1);
   hidemouse;bar(x+1,y+1,x1-1,y1-1,15);showmouse;
   draw;
  end;
 end;
end;


end.