unit man_xms;
interface
type       XFileType=record
                  handle:word;
                  pozition,
                  size:longint;
                end;
var XMSaddr:longint;
    XMSerror:byte;

function  XMSerrmesage(err:byte):string;
function  testXMS:boolean;
function  XMSver:word;
function  XMSmaxblock:word;
function  XMSfree:word;
procedure reallocXMS(handle,length:word);
function  allocXMS(size:word):word;
procedure deallocXMS(handle:word);
procedure moveXMS(SHandle,SSeg,SOfs,DHandle,DSeg,DOfs:word;Length:longint);
procedure basetoXMS(SSeg,SOfs,DHandle:word;Length:longint);
procedure XMStoBase(SHandle,DSeg,DOfs:word;Length:longint);
procedure XMStoXMS(SHandle,DHandle:word;Length:longint);

procedure XAssign(var f:XFileType;size:word);
procedure XRead(var f:XFileType;dest:pointer;size:longint);
procedure XWrite(var f:XFileType;dest:pointer;size:longint);
procedure XSeek(var f:XFileType;poz:longint);
function  XPoz(var f:XFileType):longint;
function  XSize(var f:XFileType):longint;
procedure XClose(var f:XFileType);

procedure xputpicture(vx,vy:word;xms:xfiletype;start:longint);
procedure mgetpicture(x,y,x1,y1:integer;p:pointer);
procedure xgetpicture(x,y,x1,y1:word;xms:xfiletype;start:longint);



implementation
uses dos,vga;
{$F+}
procedure longcall(addr: longint; var regs: registers); external;
{$L d:\bp\obj\INFOPLUS}
{$F-}
function XMSerrmesage(err:byte):string;
begin
 case err of
  0  :XMSerrmesage:='Vsechno OK';
  1  :XMSerrmesage:='Neni pamet XMS';
  $80:XMSerrmesage:='Funkce XMS neni implementovana';
  $81:XMSerrmesage:='Zisteno zarizeni VDISK';
  $82:XMSerrmesage:='Nastala chyba A20';
  $8E:XMSerrmesage:='Obecna chyba ovladace XMS';
  $8F:XMSerrmesage:='Nezotavitelna chyba ovladace XMS';
  $90:XMSerrmesage:='Pamet HMA neexistuje';
  $91:XMSerrmesage:='Pamet HMA je jiz pouzivana';
  $91:XMSerrmesage:='Nevyhovuje parametr /HMAMIN=';
  $93:XMSerrmesage:='Pamet HMA neni pridelena';
  $94:XMSerrmesage:='Hardvare A20 je dosud zapnuto';
  $A0:XMSerrmesage:='Vsechna rozsirena pamet je alokovana';
  $A1:XMSerrmesage:='Vsechny rukojeti rozsirene pameti jsou pozivany';
  $A2:XMSerrmesage:='Rukojet je neplatna';
  $A3:XMSerrmesage:='Zdrojova rukojet je neplatna';
  $A4:XMSerrmesage:='Zdrojovy offset je neplatny';
  $A5:XMSerrmesage:='Cilova rukojet je neplatna';
  $A6:XMSerrmesage:='Cilovy offset je neplatny';
  $A7:XMSerrmesage:='Delka je neplatna';
  $A8:XMSerrmesage:='Presouvane oblasti maji nepovoleny presah';
  $A9:XMSerrmesage:='Nastala chyba parity';
  $AA:XMSerrmesage:='Blok neni uzamcen';
  $AB:XMSerrmesage:='Blok je uzamcen';
  $AC:XMSerrmesage:='Precteni maximalniho poctu zamku bloku';
  $AD:XMSerrmesage:='Uzamceni neuspesne';
  $B0:XMSerrmesage:='K dispozici je mensi blok UMB';
  $B1:XMSerrmesage:='Nejsou dalsi bloky horni pameti';
  $B2:XMSerrmesage:='Cislo segmentu UMB je neplatne';
 end;
end;
function testXMS:boolean;
var r:registers;
begin
 r.ah:=$43;
 r.al:=$00;
 intr($2F,r);
 if r.al=$80 then testXMS:=true else testXMS:=false;
 if r.al<>$80 then exit else
 begin
  r.AX:=$4310;
  intr($2F,r);
  XMSaddr:=longint(r.es) shl 16 + r.bx;
 end;
 XMSerror:=0;
end;
function XMSver:word;
var r:registers;
begin
 r.AX:=$4300;
 intr($2F,r);
 if r.al<>$80 then exit else
 begin
  r.AX:=$4310;
  intr($2F,r);
  XMSaddr:=longint(r.es) shl 16 + r.bx;
  r.ax:=0;
  longcall(XMSaddr, r);
  XMSver:=r.ax;
 end;
end;

function XMSmaxblock:word;
var r:registers;
begin
 r.ah:=08;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 XMSmaxblock:=r.ax;
end;
function XMSfree:word;
var r:registers;
begin
 r.ah:=08;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 XMSfree:=r.dx;
end;
procedure reallocXMS(handle,length:word);
var r:registers;
begin
 r.ah:=$0F;
 r.dx:=handle;
 r.bx:=length;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
function allocXMS(size:word):word;
var r:registers;
begin
 r.ah:=09;
 r.dx:=size;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 allocXMS:=r.dx;
end;
procedure deallocXMS(handle:word);
var r:registers;
begin
 r.ah:=$0A;
 r.dx:=handle;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure moveXMS(SHandle,SSeg,SOfs,DHandle,DSeg,DOfs:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=Shandle;Sse:=SSeg;Sof:=SOfs;Dha:=Dhandle;Dse:=DSeg;Dof:=Dofs;
 end;

 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure basetoXMS(SSeg,SOfs,DHandle:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=0;Sse:=SSeg;Sof:=SOfs;Dha:=Dhandle;Dse:=0;Dof:=0;
 end;
 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure XMStoXMS(SHandle,DHandle:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=Shandle;Sse:=0;Sof:=0;Dha:=DHandle;Dse:=0;Dof:=0;
 end;
 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure XMStoBase(SHandle,DSeg,DOfs:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=Shandle;Sse:=0;Sof:=0;Dha:=0;Dse:=Dseg;Dof:=Dofs;
 end;
 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;

procedure XAssign(var f:XFileType;size:word);
begin
 f.handle:=allocXMS(size);
 f.size:=size;
 f.pozition:=0;
end;
procedure XRead(var f:XFileType;dest:pointer;size:longint);
begin
 if f.handle=0 then
 begin
  XMSerror:=$A2;
  exit;
 end;
 moveXMS(f.handle,f.pozition div 65535,f.pozition mod 65535,0,seg(dest^),ofs(dest^),size);
 f.pozition:=f.pozition+size;
end;
procedure XWrite(var f:XFileType;dest:pointer;size:longint);
begin
 if f.handle=0 then
 begin
  XMSerror:=$A2;
  exit;
 end;
 moveXMS(0,seg(dest^),ofs(dest^),f.handle,f.pozition div 65535,f.pozition mod 65535,size);
 f.pozition:=f.pozition+size;
end;
procedure XSeek(var f:XFileType;poz:longint);
begin
 f.pozition:=poz;
end;
function  XSize(var f:XFileType):longint;
begin
 XSize:=f.size;
end;
function  XPoz(var f:XFileType):longint;
begin
 XPoz:=f.pozition;
end;
procedure XClose(var f:XFileType);
begin
 deallocXMS(f.handle);
end;
procedure xputpicture(vx,vy:word;xms:xfiletype;start:longint);
var i,l,x,y:word;buffer:array[0..2048] of byte;
begin
 xseek(xms,start);
 xread(xms,@x,2);xread(xms,@y,2);
 for i:=0 to y-1 do
 begin
   XRead(xms, @Buffer, x);
   for l:=0 to x-1 do begin putpixel(vx+l,vy+i,buffer[l]);end;
 end;

end;
procedure mgetpicture(x,y,x1,y1:integer;p:pointer);
var i,l:integer;se,off:word;
begin
 se:=seg(p^);off:=ofs(p^);
 memw[se:off]:=x1-x;
 memw[se:off+2]:=y1-y;
 for l:=0 to y1-y-1 do
 for i:=0 to x1-x-1 do
 begin
  mem[se:off+(l*(x1-x))+4+i]:=getpixel(x+i,y+l);
 end;
end;

procedure xgetpicture(x,y,x1,y1:word;xms:xfiletype;start:longint);
var wx,wy,i,l:word;buffer:array[1..2048] of byte;q:longint;
begin
 wx:=x1-x;wy:=y1-y;
 xseek(xms,start);
 xwrite(xms,@wx,2);xwrite(xms,@wy,2);q:=0;
 for i:=y to y1 do
 begin
   for l:=1 to wx do begin buffer[l]:=getpixel(x+l-1,i);end;
   XWrite(xms, @Buffer, wx);
 end;
end;
end.